/*
Copyright  2002 Covansys

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appears in all copies and that both that copyright
notice and this permission notice appear in supporting documentation. You are
not permitted to sell this software or any portion of this software without
permission and a suitable agreement with Covansys.

Covansys makes no representations about the suitability of this
software for any purpose. It is provided "as is" without express or implied
warranty.
*/

// ScreenDriverDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ScreenDriver.h"
#include "ScreenDriverDlg.h"
#include "Connect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Modify the INI file to the correct place -- currently it simply puts it in
// the working directory. The INI file just stores the IP address used so that
// it does not need to be typed in all the time.
#define INI_FILE			 ".\\QADriver.ini"

#define	ENTRY_PORTNUM  	     "Port Number"
#define	ENTRY_IPADDR  	     "Target IP Address"
#define	ENTRY_DATA      	 "Test Data"

HBITMAP hBitmap;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScreenDriverDlg dialog

CScreenDriverDlg::CScreenDriverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScreenDriverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScreenDriverDlg)
	m_sEditLog = _T("");

	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iPortno = AfxGetApp()->GetProfileInt(m_strSect, ENTRY_PORTNUM, 4050);
	char buf[80];
	GetPrivateProfileString("IP","IP", "0.0.0.0", buf, 80, INI_FILE);
	m_strIPAddr = (LPCTSTR)buf;
	m_strdata = AfxGetApp()->GetProfileString(m_strSect, ENTRY_DATA, "");
}

void CScreenDriverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScreenDriverDlg)
	DDX_Text(pDX, IDC_EDIT_PORT_NO, m_iPortno);
	DDX_Text(pDX, IDC_EDIT_TEXT, m_strdata);
    DDX_Text(pDX, IDC_IPADDRESS, m_strIPAddr);
	DDX_Control(pDX, IDC_BITMAP_AREA, m_BitmapArea);
	DDX_Text(pDX, IDC_EDIT_LOG, m_sEditLog);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScreenDriverDlg, CDialog)
	//{{AFX_MSG_MAP(CScreenDriverDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_BUTTON_CAP, OnButtonCapture)
	ON_EN_KILLFOCUS(IDC_EDIT_TEXT, OnKillfocusEditText)
	ON_BN_CLICKED(IDC_BUTTON_LOG, OnButtonLog)
	ON_BN_CLICKED(IDC_BUTTON_UP, OnButtonUp)
	ON_BN_CLICKED(IDC_BUTTON_TAB, OnButtonTab)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_BUTTON_DOWN, OnButtonDown)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_WM_KEYDOWN()
	ON_BN_CLICKED(IDC_BUTTON_AUX, OnButtonAux)
	ON_BN_CLICKED(IDC_BUTTON_BACK, OnButtonBack)
	ON_BN_CLICKED(IDC_BUTTON_HELP, OnButtonHelp)
	ON_BN_CLICKED(IDC_BUTTON_HOME, OnButtonHome)
	ON_BN_CLICKED(IDC_BUTTON_OK, OnButtonOk)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_USER, OnButtonUser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScreenDriverDlg message handlers

BOOL CScreenDriverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    // Make the following push buttons to be disabled
	GetDlgItem(IDC_BUTTON_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CAP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_TAB)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_UP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_DOWN)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_AUX)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_BACK)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_HELP)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_HOME)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_OK)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_USER)->EnableWindow(FALSE);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CScreenDriverDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScreenDriverDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
/*
HCURSOR CScreenDriverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
*/

/*****************************************************************
Function Name:  OnButtonStart
Description:    Sends Start(STX) command to the server and recevies
                and displays the current screen image of the target
				application.
******************************************************************/

void CScreenDriverDlg::OnButtonStart()
{

	UpdateData();

	// Clear log file
	m_sEditLog.Empty();

	// Send Start command to the target system
	char start = STX;
    int nSend = send(m_fd, (char *) &start,  1, 0);

	if (ERROR_RETCODE(nSend))
	{
      ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
      return;
	}

	// Receive image on the target system and display
	int count = 0;
	int i = 0;
	int nRecv, width, height;

	char * buf = new char[3000000];
	char * tempBuf;
	char szMessage[1024];

	char Reply = ACK;
	char temp;

	// Determine the current time so that we can time the receive operation
	CTime time = GetCurrentTime();
	time_t lStartTime = time.GetTime();

	tempBuf = buf;
	do
	{

		memset(szMessage, '\0', 1024);
		temp = 0;

		nRecv = recv(m_fd, (char *) &szMessage, 1024, 0);

		if (ERROR_RETCODE(nRecv))
		{
		::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
		return;
		}
		else if (nRecv == 0)
		{
		::MessageBox (NULL, "No data received\n" , "Error", 0);
		return;
		}
		count += nRecv;

		if (nRecv != 1)
		{
		int j = 0;
		memcpy(tempBuf, &szMessage[j], 1024);
		tempBuf = tempBuf + 1024;
		}
		nSend = send(m_fd, (char *) &Reply,  1, 0);

		if (ERROR_RETCODE(nSend))
		{
		::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
		return;
		}
		if (nRecv == 1)
		{
		temp = szMessage[0];

		}

	}   while ( temp != EOT );

	// Determine the finish time and print the results
	time = GetCurrentTime();
	time_t lEndTime = time.GetTime();
	CString strTemp;
	strTemp.Format("Receive Time: %ld\n", lEndTime - lStartTime);
	OutputDebugString(strTemp);

	// Receive Width & Height of bitmap from the server
	char WidthHeight[20];
	char WidthHeight1[7];

	memset(WidthHeight, '\0', 20);
	memset(WidthHeight, '\0', 7);

	nRecv = recv(m_fd, (char *) &WidthHeight, 20, 0);
	if (ERROR_RETCODE(nRecv))
	{
	   ::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
	   return;
	}
	else if (nRecv == 0)
	{
	   ::MessageBox (NULL, "No data received\n" , "Error", 0);
	   return;
	}

	int n = 0;

	for (int m = 0; m < 14; m++)
	{
	   if (WidthHeight[m] != '\0')
	   {
		 WidthHeight1[n] = WidthHeight[m];
		 n++;
	   }
	}


	char sep[] = ",\t\n";
	char *token;

	token = strtok((char *)&WidthHeight1, sep);
	width = atoi(token);
	if (token != NULL)
	{
		token = strtok(NULL, sep);
		height = atoi(token);
	}

	// Copy the bitmap and place it into the label on the dialog
	CopyBitmap((BGRBit *) buf, width, height);

	Invalidate();
	UpdateWindow();
	UpdateData(FALSE);

	// Delete the buffer containing the bitmap data
	if (buf != NULL)
		delete buf;

	return;

}

/*****************************************************************
Function Name:  OnButtonCapture
Description:    Sends Capture(SOH) command to the server and recevies
                and displays the current screen image of the target
				application.

******************************************************************/
void CScreenDriverDlg::OnButtonCapture()
{

	// Send Capture command to the target system
	char command = SOH;
    int nSend = send(m_fd, (char *) &command,  1, 0);

	if (ERROR_RETCODE(nSend))
	{
      ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
      return;
	}

	// Receive image on the target system and display
    int count = 0;
    int i = 0;
	int nRecv, width, height;

    char * buf = new char[3000000];
	char * tempBuf;
    char szMessage[1024];
    char Reply = ACK;
	char temp;

	tempBuf = buf;

	// Determine the current time so that we can time the receive operation
	CTime time = GetCurrentTime();
	time_t lStartTime = time.GetTime();

	do
	{
		memset(szMessage, '\0', 1024);
	    temp = 0;

       nRecv = recv(m_fd, (char *) &szMessage, 1024, 0);

       if (ERROR_RETCODE(nRecv))
	   {
			::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
			// Free allocated memory
			if (buf != NULL)
				delete buf;
			return;
	   }
	   else if (nRecv == 0)
	   {
			::MessageBox (NULL, "No data received\n" , "Error", 0);
			// Free allocated memory
			if (buf != NULL)
				delete buf;
			return;
	   }
 	   count += nRecv;

	   if (nRecv != 1)
	   {
		 int j = 0;
	     memcpy(tempBuf, &szMessage[j], 1024);
	     tempBuf = tempBuf + 1024;
	   }
	   nSend = send(m_fd, (char *) &Reply,  1, 0);

	   if (ERROR_RETCODE(nSend))
	   {
          ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
			// Free allocated memory
			if (buf != NULL)
				delete buf;
			return;
	   }
	   if (nRecv == 1)
	   {
	      temp = szMessage[0];
	   }

	} while ( temp != EOT );

	// Determine the finish time and print the results
	time = GetCurrentTime();
	time_t lEndTime = time.GetTime();
	CString strTemp;
	strTemp.Format("Receive Time: %ld\n", lEndTime - lStartTime);
	OutputDebugString(strTemp);

	// Receive Width & Height of bitmap from the server
	char WidthHeight[20];
	char WidthHeight1[7];

	memset(WidthHeight, '\0', 20);
	memset(WidthHeight, '\0', 7);

	nRecv = recv(m_fd, (char *) &WidthHeight, 20, 0);
	if (ERROR_RETCODE(nRecv))
	{
	   ::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
		// Free allocated memory
		if (buf != NULL)
			delete buf;
	   return;
	}
	else if (nRecv == 0)
	{
	   ::MessageBox (NULL, "No data received\n" , "Error", 0);
		// Free allocated memory
		if (buf != NULL)
			delete buf;
	   return;
	}

	int n = 0;

	for (int m = 0; m < 14; m++)
	{
	   if (WidthHeight[m] != '\0')
	   {
		 WidthHeight1[n] = WidthHeight[m];
		 n++;
	   }
	}


	char sep[] = ",\t\n";
	char *token;

	token = strtok((char *)&WidthHeight1, sep);
	width = atoi(token);
	if (token != NULL)
	{
		token = strtok(NULL, sep);
		height = atoi(token);
	}

	// Copy the bitmap and place it into the label on the dialog
	CopyBitmap((BGRBit *) buf, width, height);

	Invalidate();
	UpdateWindow();

	// Free allocated memory
	if (buf != NULL)
		delete buf;

	return;

}

/*****************************************************************
Function Name:  OnLButtonUp
Description:    Captures the mouse click postion and passes x,y
                co-ordinates to  AddToLogFile function

******************************************************************/

void CScreenDriverDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// Is this in the bitmap area?
	RECT rect;
	m_BitmapArea.GetWindowRect(&rect);
	RECT parentRect;
	m_BitmapArea.GetParent()->GetWindowRect(&parentRect);

	int recttop = rect.top;
	int parentrecttop = parentRect.top;

	int width = rect.right - rect.left;
	int height = rect.bottom - rect.top;
	rect.left = rect.left - parentRect.left;
	rect.right = rect.left + width;
	rect.top = rect.top - parentRect.top - 23;  // 23 = Approx size of title bar/non-client area

	rect.bottom = rect.top + height;

	recttop = rect.top;
	parentrecttop = parentRect.top;

	int pointx = point.x ;
	int pointy = point.y ;
	int rectleft = rect.left ;
	int rectright = rect.right ;
	int rectbot = rect.bottom ;

	if ((point.x >= rect.left) && (point.x <= rect.right) &&
				(point.y >= rect.top) && (point.y <= rect.bottom))
	{
		 // Subtract the position of the rect from the point
        point.x = point.x - rect.left;
        point.y = point.y - rect.top ;

		CString strTemp;
		strTemp.Format(_T("Point Clicked: x=%d,y=%d"),point.x,point.y);

		CString strNewData;
		strNewData.Format("CLICK      %d,%d",point.x,point.y);
	    AddToLogFile(strNewData);


	}

	CDialog::OnLButtonUp(nFlags, point);
}

void CScreenDriverDlg::OnKillfocusEditText()
{
	// TODO: Add your control notification handler code here
	 CString	strNewData;
	 GetDlgItemText(IDC_EDIT_TEXT, strNewData);
	 if (strNewData != "\0")
	 {
     strNewData = "TYPE      "+ strNewData ;
	 AddToLogFile(strNewData);
	 }
}

/*****************************************************************
Function Name:  AddToLogFile
Description:    Key inputs and mouse click events are added into
                Edit Log to be displayed. Collects all the events
				information and passes on to SendAndRecv function

******************************************************************/
// Add key inputs and mouse clicks info to edit log
void CScreenDriverDlg::AddToLogFile(CString strNewData)
{

    strNewData = strNewData + "\r\n";
	m_sEditLog = m_sEditLog + strNewData ;
	databuf = databuf + strNewData ;
	UpdateData(FALSE);

	if (strNewData == "SEND\r\n")
	{
		SendAndRecv(databuf);
		databuf = "\0";
	}

}

void CScreenDriverDlg::OnButtonLog()
{
	// TODO: Add your control notification handler code here
     // on Enter key pressed
	 CString	strNewData;
	 GetDlgItemText(IDC_EDIT_TEXT, strNewData);
	 if (strNewData != "\0")
	 {
       strNewData = "TYPE      "+ strNewData ;
	   AddToLogFile(strNewData);
	   strNewData = "KEY         ENTER";
	   AddToLogFile(strNewData);

	 }

}

void CScreenDriverDlg::OnButtonDown()
{
	// TODO: Add your control notification handler code here
	 // On Down pushbutton pressed
	 CString	strNewData;

	 strNewData = "KEY         DOWN";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonUp()
{
	// TODO: Add your control notification handler code here
	// On Up pushbutton pressed
	 CString	strNewData;

	 strNewData = "KEY         UP";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonTab()
{
	// TODO: Add your control notification handler code here
	// On Tab pushbutton pressed
	 CString	strNewData;

	 strNewData = "KEY         TAB";
	 AddToLogFile(strNewData);

}

/*****************************************************************
Function Name:  SendAndRecv
Description:    Key inputs and mouse click events are to be sent to
                the target system and receive the next screen image
				on the target system

******************************************************************/
void CScreenDriverDlg::SendAndRecv(CString strNewData)
{

    m_strdata = strNewData + "\0";

	// send Send command
	char Command = ETX;

	int nSend = send(m_fd, (char *) &Command,  1, 0);

	if (ERROR_RETCODE(nSend))
	{
          ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
          return;
	}

	// Receive Acknowledgment
	char Rep;

	int nRecv = recv(m_fd, (char *)&Rep, 1, 0);

    if (Rep != ACK)
    {
		 ::MessageBox (NULL, "FAILED to Recv Ack\n" , "Error", 0);
          return;
    }

	// Send Mouse click event data
	nSend = send(m_fd, m_strdata,  strlen(m_strdata), 0);

	if (ERROR_RETCODE(nSend))
	{
          ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
          return;
	}
	m_strdata = "\0";

	// Receive image on the target system and display

	// Send Capture command to the target system
	char command = SOH;
    nSend = send(m_fd, (char *) &command,  1, 0);

	if (ERROR_RETCODE(nSend))
	{
      ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
      return;
	}

	// Receive image on the target system and display
    int count = 0;
    int i = 0;
	int width, height;

    char * buf = new char[3000000];
	char * tempBuf;
    char szMessage[1024];
	char Reply = ACK;
    char temp;


	// Determine the current time so that we can time the receive operation
	CTime time = GetCurrentTime();
	time_t lStartTime = time.GetTime();

	tempBuf = buf;
	do
	{

		memset(szMessage, '\0', 1024);
		temp = 0;

		nRecv = recv(m_fd, (char *) &szMessage, 1024, 0);

		if (ERROR_RETCODE(nRecv))
		{
			::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
			return;
		}
		else if (nRecv == 0)
		{
			::MessageBox (NULL, "No data received\n" , "Error", 0);
			return;
		}
		count += nRecv;

		if (nRecv != 1)
		{
			int j = 0;
			memcpy(tempBuf, &szMessage[j], 1024);
			tempBuf = tempBuf + 1024;
		}
		nSend = send(m_fd, (char *) &Reply,  1, 0);

		if (ERROR_RETCODE(nSend))
		{
			::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
			return;
		}

		if (nRecv == 1)
		{
			temp = szMessage[0];
		}

	}   while ( temp != EOT );

	// Determine the finish time and print the results
	time = GetCurrentTime();
	time_t lEndTime = time.GetTime();
	CString strTemp;
	strTemp.Format("Receive Time: %ld\n", lEndTime - lStartTime);
	OutputDebugString(strTemp);

	// Receive Width & Height of bitmap from the server
	char WidthHeight[20];
	char WidthHeight1[7];

	memset(WidthHeight, '\0', 20);
	memset(WidthHeight, '\0', 7);

	nRecv = recv(m_fd, (char *) &WidthHeight, 20, 0);
	if (ERROR_RETCODE(nRecv))
	{
	   ::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
	   return;
	}
	else if (nRecv == 0)
	{
	   ::MessageBox (NULL, "No data received\n" , "Error", 0);
	   return;
	}

	int n = 0;

	for (int m = 0; m < 14; m++)
	{
	   if (WidthHeight[m] != '\0')
	   {
		 WidthHeight1[n] = WidthHeight[m];
		 n++;
	   }
	}


	char sep[] = ",\t\n";
	char *token;

	token = strtok((char *)&WidthHeight1, sep);
	width = atoi(token);
	if (token != NULL)
	{
		token = strtok(NULL, sep);
		height = atoi(token);
	}

	// Copy the bitmap and place it into the label on the dialog
	CopyBitmap((BGRBit *) buf, width, height);

	Invalidate();
	UpdateWindow();

	return;

}

/*****************************************************************
Function Name:  OnConnect
Description:    Socket initialisation is done and tries to connect
                to the server application with the given IP address
				and port no and should receive the acknowledgement
				back from the server on successful connection and
				disabled push buttons to be enabled.

******************************************************************/
void CScreenDriverDlg::OnConnect()
{

	UpdateData();

	if (!SocketInit())
	{
	    ::MessageBox (NULL, "Could not initialize the WinSock system\n" , "Message Box", 0);
	    return ;
	}

	CString temp ;
	temp = "IP=";
	temp = temp + m_strIPAddr + "\0";

	//	Put the IP address in INI file
	WritePrivateProfileSection("IP", temp, INI_FILE);

    m_fd = ConnectTo(m_strIPAddr,m_iPortno);
    if (ERROR_SOCKETFD(m_fd))
    {
		::MessageBox (NULL, "Could not connect to the server\n" , "Message Box", 0);
   	    return ;
    }
	else
	{
		GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_CAP)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_TAB)->EnableWindow(TRUE);
	    GetDlgItem(IDC_BUTTON_UP)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_DOWN)->EnableWindow(TRUE);
	    GetDlgItem(IDC_BUTTON_AUX)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_BACK)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_HELP)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_HOME)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_OK)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_USER)->EnableWindow(TRUE);

		// Recv Acknowledgment from Server on successful connection
		char Reply ;
        int  nRecv = recv(m_fd, (char *) &Reply, 1, 0);

	    if (ERROR_RETCODE(nRecv))
		{
           ::MessageBox (NULL, "FAILED to Recv\n" , "Error", 0);
           return;
		}
	    else if (nRecv == 0)
		{
		   ::MessageBox (NULL, "No data received\n" , "Error", 0);
		   return;
		}

        if (Reply != ACK)
		{
			::MessageBox (NULL, "Ack not received\n" , "Error", 0);
		}
	}
}

/*****************************************************************
Function Name:  OnButtonStop
Description:    Send Stop(EOT) command to the server, disable push
                buttons, clean up the log file and socket connection
				and delete if there is any target image displaying
				on the window.

******************************************************************/


// Send Stop command to the target system
void CScreenDriverDlg::OnButtonStop()
{
	// TODO: Add your control notification handler code here
	char start = EOT;
    int nSend = send(m_fd, (char *) &start,  1, 0);

	if (ERROR_RETCODE(nSend))
	{
      ::MessageBox (NULL, "FAILED to Send\n" , "Error", 0);
      return;
	}

	// Disable all the push buttons other than Connect
	GetDlgItem(IDC_BUTTON_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CAP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_TAB)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_UP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_DOWN)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_DOWN)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_AUX)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_BACK)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_HELP)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_HOME)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_OK)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_USER)->EnableWindow(FALSE);


	// Clear the log file
    m_sEditLog.Empty();

	// Clean up the socket connection
	WSACleanup( );

	// Delete the current bmp displayed on the screen
	DeleteObject(hBitmapResult);
	Invalidate();
	UpdateWindow();
	UpdateData(FALSE);
	return;

}

void CScreenDriverDlg::OnButtonSend()
{
	// TODO: Add your control notification handler code here
	// On the Send push button pressed
	CString	strNewData;
	strNewData = "SEND";
	AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonAux()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         AUX";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonBack()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         BACK";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonHelp()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         HELP";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonHome()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         HOME";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonOk()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         OK";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonReset()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         RESET";
	 AddToLogFile(strNewData);

}

void CScreenDriverDlg::OnButtonUser()
{
	// TODO: Add your control notification handler code here
	CString	strNewData;

	 strNewData = "KEY         USER";
	 AddToLogFile(strNewData);

}


void CScreenDriverDlg::CopyBitmap(BGRBit *pBGR, int nWidth, int nHeight)
{
	// If there is a bitmap already stored in the module level
	// bitmap object, delete it
	if ((HBITMAP) bitmap != NULL)
		bitmap.DeleteObject();

	// Create a bitmap compatible with the screen device context
	bitmap.CreateCompatibleBitmap (this->GetDC(), nWidth, nHeight);

	// Fill out the bitmap info structure -- this should be
	// identical to the server version
	BITMAPINFO dibInfo;
	dibInfo.bmiHeader.biBitCount = 24;
	dibInfo.bmiHeader.biClrImportant = 0;
	dibInfo.bmiHeader.biClrUsed = 0;
	dibInfo.bmiHeader.biCompression = 0;
	dibInfo.bmiHeader.biHeight = nHeight;
	dibInfo.bmiHeader.biPlanes = 1;
	dibInfo.bmiHeader.biSize = 40;
	dibInfo.bmiHeader.biSizeImage = nWidth*nHeight*3;
	dibInfo.bmiHeader.biWidth = nWidth;
	dibInfo.bmiHeader.biXPelsPerMeter = 3780;
	dibInfo.bmiHeader.biYPelsPerMeter = 3780;
	dibInfo.bmiColors[0].rgbBlue = 0;
	dibInfo.bmiColors[0].rgbGreen = 0;
	dibInfo.bmiColors[0].rgbRed = 0;
	dibInfo.bmiColors[0].rgbReserved = 0;

	// Create a temporary device context that will be used
	// to copy the bitmap
	CDC dc;
	dc.CreateCompatibleDC(this->GetDC());
	// Use the module level bitmap as the destination for the
	// device dependent bitmap
	CBitmap *pOldBitmap = dc.SelectObject(&bitmap);
	// Copy the DI bits into the device dependent bitmap
	// We use SetDIBits here instead of SetBitmapBits because it will
	// accept the data in BGR format instead of RGB format.
	SetDIBits(dc, bitmap, 0, nHeight, pBGR, &dibInfo, DIB_RGB_COLORS);
	// Select the old bitmap back into the device context to
	// avoid resource leaks
	dc.SelectObject(pOldBitmap);
	dc.DeleteDC();

	// Place the bitmap into the CStatic
	HBITMAP hOldBitmap = m_BitmapArea.SetBitmap(bitmap);

}

