/*
Copyright  2002 Covansys

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appears in all copies and that both that copyright
notice and this permission notice appear in supporting documentation. You are
not permitted to sell this software or any portion of this software without
permission and a suitable agreement with Covansys.

Covansys makes no representations about the suitability of this
software for any purpose. It is provided "as is" without express or implied
warranty.
*/

// ScreenDriverDlg.h : header file
//

#if !defined(AFX_SCREENDRIVERDLG_H__B8B22309_71FB_4DFF_9954_2122027829A7__INCLUDED_)
#define AFX_SCREENDRIVERDLG_H__B8B22309_71FB_4DFF_9954_2122027829A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// The BGRBit structure will contain the color data for a single
// bit
struct BGRBit
{
	byte B;
	byte G;
	byte R;
};

/////////////////////////////////////////////////////////////////////////////
// CScreenDriverDlg dialog

class CScreenDriverDlg : public CDialog
{
// Construction
public:
	void SendAndRecv(CString strNewData);

	HBITMAP hBitmapResult;
	CString m_strSect;
	CString m_strdata;
	int m_iPortno;
	CString m_strIPAddr;
	SOCKET  m_fd;       // Socket communication handle
	CStatic	m_BitmapArea;
	CString databuf;
	CBitmap bitmap;

	CScreenDriverDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CScreenDriverDlg)
	enum { IDD = IDD_SCREENDRIVER_DIALOG };
	CString	m_sEditLog;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScreenDriverDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CScreenDriverDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnButtonStart();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnButtonCapture();
	afx_msg void OnKillfocusEditText();
	afx_msg void OnButtonLog();
	afx_msg void OnButtonUp();
	afx_msg void OnButtonTab();
	afx_msg void OnConnect();
	afx_msg void OnButtonDown();
	afx_msg void OnButtonStop();
	afx_msg void OnButtonSend();
	afx_msg void OnButtonAux();
	afx_msg void OnButtonBack();
	afx_msg void OnButtonHelp();
	afx_msg void OnButtonHome();
	afx_msg void OnButtonOk();
	afx_msg void OnButtonReset();
	afx_msg void OnButtonUser();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Implementation

private:
	void AddToLogFile(CString strNewData);
	void CopyBitmap(BGRBit *pBGR, int nWidth, int nHeight);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCREENDRIVERDLG_H__B8B22309_71FB_4DFF_9954_2122027829A7__INCLUDED_)
