/*
Copyright  2002 Covansys

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appears in all copies and that both that copyright
notice and this permission notice appear in supporting documentation. You are
not permitted to sell this software or any portion of this software without
permission and a suitable agreement with Covansys.

Covansys makes no representations about the suitability of this
software for any purpose. It is provided "as is" without express or implied
warranty.
*/

#include "stdafx.h"
#include "conn.h"
#include "stdlib.h"



bool SocketInit(void)
{
	WORD wVersionRequested;
	WSADATA wsaData;
	int err;
	wVersionRequested = MAKEWORD( 1, 1 );
	err = WSAStartup( wVersionRequested, &wsaData );

	if ( err != 0 )
	{
//		::MessageBox (NULL, "WSAStartup failed\n" , "Message Box", 0);
		return false;
	}

	if ( LOBYTE( wsaData.wVersion ) != 1 ||
			HIBYTE( wsaData.wVersion ) != 1 )
	{
//		::MessageBox (NULL, "Failed for WinSock DLL version 1.1\n" , "Message Box", 0);
		WSACleanup( );
		return false;
	}
	return true;
}
void SocketDeinit(void)
{
	WSACleanup( );
}

//
// Function: ConnectToScale
//
// Description: Connect to the target through ethernet.
// If it connects successfully, returns the socket descriptor
// otherwise, it returns the value of INVALID_SOCKET.
//
// parameters:
// ipaddr: must specify the IP address in standard dot notation
// port: the port number of the scale application
//
SOCKET	ConnectTo()
{

	SOCKET       sock_Listen, sock_Accept;
	SOCKADDR_IN	 addr_Srv, addr_Cli;
	int          clilen;
    int          listenport = 4050;


    /* Create the server-side socket */
	//-- Open a TCP socket to listen on
    sock_Listen = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);


	if (ERROR_SOCKETFD(sock_Listen))
	{
		MessageBox (NULL, TEXT("Function socket() failed\n") , TEXT("Error"), 0);
		return INVALID_SOCKET;
	}

	//-- Fill in structure fields for binding to local host
    memset((char *) &addr_Srv, 0, sizeof(addr_Srv));
    addr_Srv.sin_family      = AF_INET;
    addr_Srv.sin_addr.s_addr = htonl(INADDR_ANY);
    addr_Srv.sin_port        = htons(listenport);


	/* Bind socket to the appropriate port and interface (INADDR_ANY) */

    if (bind(sock_Listen, (sockaddr*)&addr_Srv, sizeof(addr_Srv)) ==SOCKET_ERROR)
	{
		MessageBox (NULL, TEXT("Binding socket failed\n") , TEXT("Error"), 0);
		closesocket(sock_Listen);
		return INVALID_SOCKET;
	}

	/* Listen for incoming connections */

    if (listen(sock_Listen,1)==SOCKET_ERROR)
	{
        MessageBox (NULL, TEXT("Listening to the client failed\n") , TEXT("Error"), 0);
	    closesocket(sock_Listen);
		return INVALID_SOCKET;
	}


    //-- Prepare Client address to receive new data
    memset(&addr_Cli, 0, sizeof(addr_Cli));
    clilen = sizeof(addr_Cli);

	/* Accept and service incoming connection requests  */
	if ((sock_Accept = accept(sock_Listen, (sockaddr*)&addr_Cli, &clilen)) < 0)
	{
		 MessageBox (NULL, TEXT("Function accept() failed\n") , TEXT("Error"), 0);
	}


    closesocket (sock_Listen);
	return sock_Accept;
}
