/*
Copyright  2002 Covansys

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appears in all copies and that both that copyright
notice and this permission notice appear in supporting documentation. You are
not permitted to sell this software or any portion of this software without
permission and a suitable agreement with Covansys.

Covansys makes no representations about the suitability of this
software for any purpose. It is provided "as is" without express or implied
warranty.
*/

// QASrvr1Dlg.cpp : implementation file
//

/*
	Modify the following definition to use this tool with a different
	application. This should the name (the text that appears in the
	window title) of the application you wish to test.
 */
#define TARGET_APPLICATION		_T("TargetApp")

#include "stdafx.h"
#include "QASrvr.h"
#include "QASrvrDlg.h"
#include "Conn.h"

#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CQASrvr1Dlg dialog

CQASrvr1Dlg::CQASrvr1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CQASrvr1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CQASrvr1Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CQASrvr1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQASrvr1Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
//	DDX_Control(pDX, IDC_BITMAP_AREA, m_BitmapArea);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CQASrvr1Dlg, CDialog)
	//{{AFX_MSG_MAP(CQASrvr1Dlg)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQASrvr1Dlg message handlers

BOOL CQASrvr1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// GetDesktopWindow() usually returns NULL, but CenterWindow()
	// takes NULL as a default value and seems to handle it appropriately.
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// WARNING! The following line could adversely affect the application
	// that you are attempting to test or drive from a remote PC. The
	// priority is being increased here to ensure that the time required
	// to transmit the bitmap across the network is reasonable. The average
	// time to send a 230k bitmap is about 400 ms, but if another application
	// is using more processor time it may go as high as 22 seconds or higher.
	//
	// A better or additional solution would be to compress the image
	// being sent across the network so that it does not take as long
	// to send it. This could be a lengthy task with the reduced APIs
	// out there for WinCE. Since this solution works for us, we give
	// this thread a slightly higher priority than the other applications
	// running on the system.
	CeSetThreadPriority(AfxGetThread()->m_hThread, 150);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CQASrvr1Dlg::OnConnect()
{
	// TODO: Add your control notification handler code here

	UpdateData();

	if (!SocketInit())
	{
		MessageBox (TEXT("Could not initialize the WinSock system\n"), TEXT("Message Box"), 0);
		return ;
	}


	m_fd = ConnectTo();
	if (ERROR_SOCKETFD(m_fd))
	{
		MessageBox (TEXT("Could not connect to the Server\n"), TEXT("Message Box"), 0);
		return ;
	}


	// Send ACK on successful connection

	char Ack = ACK;
	int nSend = send(m_fd, (char *)&Ack, 1, 0);

	if (ERROR_RETCODE(nSend))
	{
	    MessageBox(TEXT("FAILED to Send\n"), TEXT("Message Box"), 0);
		return;
	}

	// Minimize this window so it stays out of the way of
	// the application being driven remotely
    ShowWindow(SW_MINIMIZE);

	// Retrieve a pointer to the CWnd of the application that
	// will be driven remotely. This is necessary because
	// we will need a reference to its device context.
    pDriverWindow = FindWindow(NULL, TARGET_APPLICATION);

	// Enter the main communication loop. NOTE: Future enhancements
	// would put this into a separate thread and make the communication
	// a more event driven.
	for (;;)
    {

		char Command;
		// Minimize the window
		ShowWindow(SW_MINIMIZE);

		int  nRecv = recv(m_fd, (char *) &Command, 1, 0);

		if(nRecv ==0)
		{
			::MessageBox (NULL, TEXT("No data received\n"), TEXT("Error"), 0);
			return;
		}
		//Data sent Command
		if (Command == ETX)
		{
			char Reply = ACK;

			int nSend = send(m_fd, (char *) &Reply, 1, 0);
			if (ERROR_RETCODE(nSend))
			{
				::MessageBox(NULL, TEXT("FAILED to Send\n"), TEXT("Message Box"), 0);
				return;
			}

			char buf[2000];
			memset(buf, '\0', 2000);
			int  nRecv = recv(m_fd, (char *) &buf, 2000, 0);

			if ( ERROR_RETCODE(nRecv))
			{
				::MessageBox (NULL, TEXT("FAILED to Recv Command\n"), TEXT("Error"), 0);
				return;
			}
			else if(nRecv ==0)
			{
				::MessageBox (NULL, TEXT("No data received\n"), TEXT("Error"), 0);
				return;
			}
			// Process the data
			mouseevent((char *)&buf);
		}
		else if (Command == EOT)  // For Stop Command
		{
			ShowWindow(SW_SHOW);  // Show the window
			closesocket(m_fd);    // Close the socket
			WSACleanup( );        // Clean up existing socket connections
			break;
		}
		else if((Command == SOH) || (Command == STX))  // Start or Capture command
		{

			// Send the bitmap to the client
			CRect		rect;
			CDC dc;

			// Take a snapshot of the screen
			dc.CreateCompatibleDC(pDriverWindow->GetDC());

			// Retrieve the dimensions of the application window
			pDriverWindow->GetWindowRect(&rect);
			int nWidth = rect.Width();
			int nHeight = rect.Height();

			// The corrected width of the bitmap we will be sending
			// to the client
			int nCorrectedWidth = ((nWidth + 3 )/ 4) * 4;

			// Fill in the DIB structure
			BITMAPINFO dibInfo;
			dibInfo.bmiHeader.biBitCount = 24;
			dibInfo.bmiHeader.biClrImportant = 0;
			dibInfo.bmiHeader.biClrUsed = 0;
			dibInfo.bmiHeader.biCompression = 0;
			dibInfo.bmiHeader.biHeight = nHeight;
			dibInfo.bmiHeader.biPlanes = 1;
			dibInfo.bmiHeader.biSize = 40;
			dibInfo.bmiHeader.biSizeImage = nCorrectedWidth*nHeight*3;
			dibInfo.bmiHeader.biWidth = nCorrectedWidth;
			dibInfo.bmiHeader.biXPelsPerMeter = 3780;
			dibInfo.bmiHeader.biYPelsPerMeter = 3780;
			dibInfo.bmiColors[0].rgbBlue = 0;
			dibInfo.bmiColors[0].rgbGreen = 0;
			dibInfo.bmiColors[0].rgbRed = 0;
			dibInfo.bmiColors[0].rgbReserved = 0;

			// Create a new device independent bitmap and retrieve
			// a pointer to its bit storage -- this is the raw
			// bitmap data that will be sent to the client
			BGRBit *pBGR = NULL;
			HBITMAP hNewBitmap = CreateDIBSection(dc.GetSafeHdc(),
							(const BITMAPINFO*)&dibInfo,
							DIB_RGB_COLORS, (void**)&pBGR, NULL, 0);
			HBITMAP hOldBitmap = (HBITMAP) dc.SelectObject(hNewBitmap);

			// Copy the bitmap into the new device context -- this will
			// also copy the bitmap to the DIB
			dc.BitBlt(rect.left, rect.top, rect.Width(),
					rect.Height(), pDriverWindow->GetDC(),
					0, 0, SRCCOPY);

			// Determine the buffer size of the data to be sent
			// to the client
			int bufSize = sizeof(*pBGR) * ((rect.Width() + 3 ) / 4 ) * 4 * rect.Height();

			int uBytesWritten = bufSize;
			int height = rect.Height();
			int width = rect.Width();

			TCHAR WidthHeight[20];
			wsprintf(WidthHeight, _T("%d,%d"), width, height);

			int i = 0;
			int count = 0;
			char buf;
			// Send the bitmap data to the client
			do
			{

				int	nSend = send(m_fd, (char *) pBGR+i,  1024, 0);
				if (ERROR_RETCODE(nSend))
				{
					MessageBox(TEXT("FAILED to Send\n"), TEXT("Message Box"), 0);
					return;
				}
				count = count + nSend;

				int  nRecv = recv(m_fd, (char *) &buf, 1, 0);
				if ( buf != ACK)
				{
					MessageBox(TEXT("FAILED to Recv Ack\n"), TEXT("Error"), 0);
					return;
				}

				i += 1024;

			} while (count <= uBytesWritten);


			char EndData = EOT; // Send End of data command

			int  nSend = send(m_fd, (char *) &EndData, 1, 0);
			if (ERROR_RETCODE(nSend))
			{
				MessageBox(TEXT("FAILED to Send\n"), TEXT("Message Box"), 0);
				return;
			}

			int  nRecv = recv(m_fd, (char *) &buf, 1, 0);

			if ( buf != ACK)
			{
				MessageBox(TEXT("FAILED to Recv Ack\n"), TEXT("Error"), 0);
				return;
			}

		  // Send Width & Height of the bitmap to client


			nSend = send(m_fd, (char *) WidthHeight, 20, 0);
			if (ERROR_RETCODE(nSend))
			{
				MessageBox(TEXT("FAILED to Send\n"), TEXT("Message Box"), 0);
				return;
			}

			// Restore the empty bitmap to the device context -- this
			// clears up any potential resource leaks
			dc.SelectObject(hOldBitmap);
			// Delete the DIB
			DeleteObject(hNewBitmap);

		}  //else if

    } //for


  return;
}

// Process the data received from the client
void CQASrvr1Dlg::mouseevent(char* databuf)
{

	char sep[] = "\r\n";
	TCHAR seps[]   = _T(" ,\t\n");
	CString strArray[35];
    char *token;
	TCHAR *token1;
	TCHAR *xco;
	TCHAR *yco;
	TCHAR *Up;
	TCHAR *Down;
	TCHAR *Enter;
	TCHAR *Tab;
    TCHAR *Aux;
    TCHAR *Back;
    TCHAR *Help;
    TCHAR *Home;
    TCHAR *Ok;
    TCHAR *Reset;
    TCHAR *User;
	TCHAR *Click;
	TCHAR *Type;
	TCHAR *Typevalue;
	TCHAR *Key;
	int i = 0;
    WPARAM wParam;
	LPARAM lParam;

	token = strtok(databuf, sep);
	while( token != NULL )
   {
      /* While there are tokens in "string" */
     	strArray[i] = token;
		i = i + 1;
      /* Get next token: */
      token = strtok( NULL, sep );
   }

	int j = i;
	for (i=0;i < j;i++)
	{

    	token1 = _tcstok((LPTSTR)(LPCTSTR)strArray[i], seps);


        if (!(_tcscmp(token1, _T("KEY"))))
		{
			Key = token1;

		    if(token1 != NULL)
            {
               token1 = _tcstok(NULL,seps);
			}

            if (!(_tcscmp(token1, _T("BACK"))))
			{
				Back = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1000,
								MAKELPARAM(MOD_CONTROL, 'B'));	// CTRL-B Hotkey

					/*  We use hotkeys to simulate hardware keys on the
					    device. Below is a technique that might work to
						simulate CTRL characters that aren't tied to
						hotkeys. See WinCE help for hotkey information.
						NOTE: I have not tested this out yet.

					pDriverWindow->PostMessage(WM_KEYDOWN, 17, NULL);	// CTRL
					pDriverWindow->PostMessage(WM_KEYDOWN, 42, NULL);	// B
					pDriverWindow->PostMessage(WM_KEYUP, 42, 0x90000000);		// B
					pDriverWindow->PostMessage(WM_KEYUP, 17, 0x90000000);		// CTRL
					*/
				}
			}
            else if (!(_tcscmp(token1, _T("TAB"))))
			{
				Tab = token1;
				pDriverWindow->PostMessage(WM_KEYDOWN, 0x09, NULL);
			}
			else if(!(_tcscmp(token1, _T("UP"))))
			{
				Up = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1003,
								MAKELPARAM(MOD_CONTROL, 'P'));	// CTRL-U/UP Hotkey
				}
			}
			else if (!(_tcscmp(token1, _T("DOWN"))))
            {
				Down = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1008,
								MAKELPARAM(MOD_CONTROL, 'D'));	// CTRL-D/DOWN Hotkey
				}
			}
			else if (!(_tcscmp(token1, _T("ENTER"))))
			{
				Enter = token1;
				// Not applicable at this time
			}
            else if (!(_tcscmp(token1, _T("AUX"))))
			{
				Aux = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1004,
								MAKELPARAM(MOD_CONTROL, 'A'));	// CTRL-A Hotkey
				}
			}
            else if (!(_tcscmp(token1, _T("HELP"))))
			{
				Help = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1005,
								MAKELPARAM(MOD_CONTROL, 'L'));	// CTRL-L Hotkey
				}
			}
            else if (!(_tcscmp(token1, _T("HOME"))))
			{
				Home = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1002,
								MAKELPARAM(MOD_CONTROL, 'H'));	// CTRL-H Hotkey
				}
			}
            else if (!(_tcscmp(token1, _T("OK"))))
			{
				Ok = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1001,
								MAKELPARAM(MOD_CONTROL, 'O'));	// CTRL-O Hotkey
				}
			}
            else if (!(_tcscmp(token1, _T("RESET"))))
			{
				Reset = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1006,
								MAKELPARAM(MOD_CONTROL, 'R'));	// CTRL-R Hotkey
				}
			}
			 else if (!(_tcscmp(token1, _T("USER"))))
			{
				User = token1;
				if (pDriverWindow != NULL) {
					// Send the hotkey message with the appropriate
					// ID to the target application
					pDriverWindow->PostMessage(WM_HOTKEY, 1003,
								MAKELPARAM(MOD_CONTROL, 'U'));	// CTRL-U Hotkey
				}
			}
		}
		else if (!(_tcscmp(token1, _T("CLICK"))))
		{
			Click = token1;
		    if (token1 !=  NULL)
            {
			   token1 = _tcstok(NULL,seps);
			   xco = token1;

			}
			if (token1 !=  NULL)
            {
			   token1 = _tcstok(NULL,seps);
			   yco = token1;
			}

			// Now that we have received the click event, we need to adjust
			// the positioning a bit so that the click is translated properly
			// to the correct location. Note that at different resolutions
			// the hardcoded numbers might need adjusted (this has not been
			// tested at a resolution other than 640x480 at this time).
			pt.x = _wtoi(xco) + 8;
            pt.y = _wtoi(yco) + 3;

	        pWindow = WindowFromPoint(pt);

	        BOOL Result;
	        Result = SetCursorPos(pt.x, pt.y);

	        pDriverWindow->SetFocus();


			//Map the screen coordinates to the client
			pWindow->ScreenToClient(&pt);

			// Send a message to the window indicating the button press
			wParam = 0;
	        lParam = MAKELONG(pt.x, pt.y);

	        pWindow->PostMessage(WM_LBUTTONDOWN, wParam, lParam);
	        pWindow->PostMessage(WM_LBUTTONUP, wParam, lParam);

			// If this delay does not exist between mouse clicks,
			// the application will assume that this is a double click.
			// Additional changes will be required if the target
			// application requires double clicks.
			Sleep(700);   // To give time interval b/n two mouse clicks
        }
        else if (!(_tcscmp(token1, _T("TYPE"))))
		{
            Type = token1;
		    if (token1 !=  NULL)
            {
				token1 = _tcstok(NULL,seps);
			    Typevalue = token1;

				int len = _tcslen(Typevalue);
				for (int k = 0; k < len; k++)
				{
                  pWindow->PostMessage(WM_KEYDOWN, 0x2E, NULL);
				  pWindow->PostMessage(WM_CHAR, Typevalue[k], NULL);

				}
            }
		}

    }

	ReleaseCapture();

	// Provide a small delay before communications restart -- this will allow
	// the client to receive a new bitmap, but only after a delay to allow
	// the GUI to refresh. You may wish to adjust this in the future to
	// provide a smaller delay.
	Sleep(600);

	return;
}

