/**
	28/10/2002
	@author		Bogdan Dorohonceanu
 */

package fn;

public class Interval {

    double length;
    double upper;
    double lower;

    public Interval () throws Exception {
        set(0.0, 0.0);
    }

    public Interval (double x) throws Exception {
        set(x, x);
    }

    public Interval (double lower, double upper) throws Exception {
        set(lower, upper);
    }

    public Interval (Interval cf) throws Exception {
        set(cf.lower, cf.upper);
    }

    public void set (double lower, double upper) throws Exception {
    	double m = 100000.0;
    	lower = Math.floor(lower * m + 0.5f) / m;
    	upper = Math.floor(upper * m + 0.5f) / m;
    	//System.out.println(lower + " " + upper);
        if (upper < lower)
            throw new Exception("Bad Interval limits");
        length = upper - lower;
        this.lower = lower;
        this.upper = upper;
    }

    public static double greaterThan (Interval a, Interval b) {
        double alpha = 0.0;
        if ( a.length == 0.0 && b.length == 0.0 ) {
	    	if ( a.upper > b.lower )
		    	alpha = 1.0;
		    else if ( a.upper < b.lower )
			    alpha = 0.0;
		    else // a.upper == b.lower
			    alpha = 0.5;
	    } else {
		    alpha = ( a.upper - b.lower ) / (a.length + b.length);
		    if( alpha < 0.0 )
			    alpha = 0.0;
		    else if ( alpha > 1.0 )
			    alpha = 1.0;
	    }
	    return alpha;
    }

    public static double lessThan (Interval a, Interval b) {
	    double alpha = 0.0;
	    if ( a.length == 0.0 && b.length == 0.0 ) {
		    if ( b.upper > a.lower )
			    alpha = 1.0;
		    else if ( b.upper < a.lower )
    			alpha = 0.0;
	    	else // b.upper == a.lower
			    alpha = 0.5;
	    } else {
		    alpha = ( b.upper - a.lower ) / (a.length + b.length);
		    if( alpha < 0.0 )
			    alpha = 0.0;
		    else if ( alpha > 1.0 )
			    alpha = 1.0;
	    }
	    return alpha;
    }

    public double greaterThan (Interval cf) {
        return Interval.greaterThan( this, cf );
    }

    public double lessThan (Interval cf) {
        return Interval.lessThan( this, cf );
    }

    public boolean contains(double value) {
        return (lower <= value && value <= upper);
    }

    public double getUpper() {
        return upper;
    }

    public double getLower() {
        return lower;
    }

    public double getLength() {
        return length;
    }
}
