/**
	14/05/2002
	@author		Bogdan Dorohonceanu
 */

package fn;

import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import java.util.*;

public class PanelValue extends Panel implements ActionListener {

    protected TextField eValue;
    protected Button bMinus;
    protected Button bPlus;
    protected double min, max, step;
    protected static DecimalFormat decFormat = new DecimalFormat("0.##");
    protected Vector listeners = new Vector();

    public PanelValue(double min, double max, double step) {

        super(null);
        setSize(74,20);

        bMinus = new Button("-");
        bMinus.setFont(new Font("Dialog",Font.PLAIN,14));
        add(bMinus);
        bMinus.setBounds(0,0,20,20);

        eValue = new TextField("0.0", 4);
        eValue.setFont(new Font("Dialog",Font.PLAIN,14));
        add(eValue);
        eValue.setBounds(20,0,34,20);
        eValue.setEditable(false);

        bPlus = new Button("+");
        bPlus.setFont(new Font("Dialog",Font.PLAIN,14));
        add(bPlus);
        bPlus.setBounds(54,0,20,20);

        this.min = min;
        this.max = max;
        this.step = step;
        setValue (min);

        bMinus.addActionListener(this);
        eValue.addActionListener(this);
        bPlus.addActionListener(this);
    }

    public void actionPerformed(ActionEvent event) {
        Object source = event.getSource();
        if (source == eValue) {
            try {
                Double d = new Double(eValue.getText());
                setValue (d.doubleValue());
            } catch (Exception e) {
                setValue (min);
            }
        }
        else
        if (source == bPlus) {
                clickedBPlus();
        }
        else
        if (source == bMinus) {
                clickedBMinus();
        }
    }

    public void addPanelValueListener(PanelValueListener listener) {
    	listeners.add(listener);
    }

    public void removeAPanelValueListener(PanelValueListener listener) {
    	listeners.remove(listener);
    }

	protected void notifyPanelValueListeners(PanelValueEvent event) {
		for (Enumeration e =listeners.elements(); e.hasMoreElements(); ) {
			((PanelValueListener) e.nextElement()).panelValueChanged(event);
		}
	}

    public synchronized void setValue (double d) {
        if (d != getValue()) {
	        if (d < min) {
	            d = min;
	        }
	        else if (d > max) {
	            d = max;
	        }
	        d = Math.round(d * 100.0) / 100.0;
	        eValue.setText (decFormat.format(d));
	        notifyPanelValueListeners(new PanelValueEvent(this, d));
		}
    }


    public synchronized double getValue () {
        Double d = new Double(eValue.getText());
        return d.doubleValue();
    }

    public synchronized void clickedBMinus() {
        setValue (getValue () - step);
    }

    public synchronized void clickedBPlus() {
        setValue (getValue () + step);
    }
}

