/**
	14/05/2002
	@author		Bogdan Dorohonceanu
 */

package fn;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Fuzzy extends Applet implements /*ActionListener,*/ ItemListener {

        protected PanelFuzzyNumber pfnA1, pfnA2;
        protected PanelResults pResults;
        //protected Button bCompute;
        protected Choice cExamples;
        protected Checkbox cbB2x;
        protected Label lB2, lExamples;
        protected Picture cPicture;

    public void init() {
        super.init();

        setLayout(null);
        setSize(420,350);
        setBackground (Color.lightGray);

        cPicture = new Picture (this, 285, 220);
        add(cPicture);
        cPicture.setBounds(10,10,285, 220);

        cbB2x = new Checkbox("Variant");
        cbB2x.setFont(new Font("Dialog",Font.PLAIN,14));
        cbB2x.setState(false);
        add(cbB2x);
        cbB2x.setBounds(322,20,160,20);

        pResults = new PanelResults();
        add(pResults);
        pResults.setBounds(300,60,100,70);

        //bCompute = new Button("Compute");
        //bCompute.setFont(new Font("Dialog",Font.PLAIN,14));
        //add(bCompute);
        //bCompute.setBounds(310,140,90,24);

        lExamples = new Label("Examples", Label.LEFT);
        lExamples.setFont(new Font("Dialog",Font.PLAIN,14));
        add(lExamples);
        lExamples.setBounds(300,175,100,20);

        cExamples = new Choice();
        cExamples.setFont(new Font("Dialog",Font.PLAIN,14));
        add(cExamples);
        cExamples.setBounds(310,200,100,20);
        cExamples.addItem("None");
        cExamples.addItem("Case (a)");
        cExamples.addItem("Case (b)");
        cExamples.addItem("Case (c.1)");
        cExamples.addItem("Case (c.2)");
        cExamples.addItem("Case (c.3)");
        cExamples.addItem("Case (d)");
        cExamples.addItem("Case (e.1)");
        cExamples.addItem("Case (e.2)");
        cExamples.addItem("Case (e.3)");

        pfnA1 = new PanelFuzzyNumber(this, "A1");
        add(pfnA1);
        pfnA1.setBounds(10,230,400,55);

        pfnA2 = new PanelFuzzyNumber(this, "A2");
        add(pfnA2);
        pfnA2.setBounds(10,285,400,55);

        //bCompute.addActionListener(this);
        cbB2x.addItemListener(this);
        cExamples.addItemListener(this);
    }

    /*public void actionPerformed(ActionEvent event) {
        if (event.getSource() == bCompute) {
            compute();
        }
    }*/

    public void itemStateChanged(ItemEvent event) {
        if (event.getSource() == cExamples) {
            selectedCExamples();
        }
        else if (event.getSource() == cbB2x) {
        	compute();
        }
    }

    public synchronized void compute() {
    	try {
	        setEnabled (false);
	        FuzzyNumber A1 = pfnA1.getValue (), A2 = pfnA2.getValue ();
	        if (A1 != null && A2 != null) {
	            double alfaA1gtA2, alfaA1ltA2;
	            if (cbB2x.getState() == true) {
	                alfaA1gtA2 = FuzzyNumber.mGreaterThan (A1, A2);
	                alfaA1ltA2 = FuzzyNumber.mLessThan (A1, A2);
	            } else {
	                alfaA1gtA2 = FuzzyNumber.greaterThan (A1, A2);
	                alfaA1ltA2 = FuzzyNumber.lessThan (A1, A2);
	            }
	            if (alfaA1gtA2 == 0.0 && alfaA1ltA2 == 0.0) {
	                pResults.setValues ("", "");
	                cPicture.setValues (A1, A2);
	            }
	            else {
	                pResults.setValues (alfaA1gtA2, alfaA1ltA2);
	                cPicture.setValues (A1, A2);
	            }
	        }
	        else {
	            pResults.setValues ("", "");
	            cPicture.setValues (null, null);
	        }
	        cPicture.repaint ();
	        setEnabled (true);
	     }
        catch (Exception x) {
            x.printStackTrace(System.err);
        }
    }

    private synchronized void selectedCExamples() {
    	try {
	        FuzzyNumber A1 = null, A2 = null;
	        switch (cExamples.getSelectedIndex ()) {
	            case 0: // None
	                A1 = new FuzzyNumber (0.0, 0.0, 0.0);
	                A2 = new FuzzyNumber (0.0, 0.0, 0.0);
	                break;
	            case 1: // case (a)
	                A1 = new FuzzyNumber (3.0, 3.5, 4.0);
	                A2 = new FuzzyNumber (4.0, 4.5, 5.0);
	                break;
	            case 2: // case (b)
	                A1 = new FuzzyNumber (1.8, 2.5, 5.0);
	                A2 = new FuzzyNumber (0.8, 3.5, 4.0);
	                break;
	            case 3: // case (c.1) A1 > A2
	                A1 = new FuzzyNumber (2.0, 4.5, 5.0);
	                A2 = new FuzzyNumber (2.0, 3.5, 5.0);
	                break;
	            case 4: // case (c.2) A1 > A3
	                A1 = new FuzzyNumber (2.0, 4.5, 5.0);
	                A2 = new FuzzyNumber (2.0, 2.5, 5.0);
	                break;
	            case 5: // case (c.3) A2 > A3
	                A1 = new FuzzyNumber (2.0, 3.5, 5.0);
	                A2 = new FuzzyNumber (2.0, 2.5, 5.0);
	                break;
	            case 6: // case (d)
	                A1 = new FuzzyNumber (1.0, 2.5, 4.0);
	                A2 = new FuzzyNumber (2.0, 2.5, 3.0);
	                break;
	            case 7: // case (e.1) A1 > A2
	                A1 = new FuzzyNumber (1.5, 2.5, 4.0, 4.5);
	                A2 = new FuzzyNumber (1.5, 2.5, 4.5);
	                break;
	            case 8: // case (e.2) A1 > A3
	                A1 = new FuzzyNumber (1.5, 2.5, 4.0, 4.5);
	                A2 = new FuzzyNumber (1.5, 2.5, 3.5);
	                break;
	            case 9: // case (e.3) A2 > A3
	                A1 = new FuzzyNumber (1.5, 2.5, 4.5);
	                A2 = new FuzzyNumber (1.5, 2.5, 3.5);
	                break;
	        }
	        pfnA1.setValue (A1);
	        pfnA2.setValue (A2);
	    }
        catch (Exception x) {
            x.printStackTrace(System.err);
        }
    }
}
